// constellation.cpp: implementation of the constellation class.
//
//////////////////////////////////////////////////////////////////////

#include "constellation.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

char tps[]="00";
char tps4[]="0000";
char lesSegments[300];
unsigned int HR;

constellation::constellation()
{
}

constellation::~constellation()
{	delete Dessin;
}


int constellation::Lire(ifstream & liste, LesEtoiles & VouteCeleste)
// Lis les infos de la constellation et rcupre les x,y et z des etoiles
// Le fichier des constellation doit etre fini sur une ligne vide (faire entree sur la derniere ligne quoi....)
{

#if defined( WIN32 )
	liste.read(Nom, 21);
	Nom[21]='\0';
	//cout << Nom;
	liste.read(Abreviation, 3);
	Abreviation[3]='\0';
	//cout << Abreviation;
	liste.read(Inter, 19);
	Inter[19]='\0';
	//cout << Inter;
	liste.read(tps,2);
	NbSegments=atoi(tps);
	//cout << NbSegments << " : ";
   	liste.get();
	liste.read(lesSegments,NbSegments*2*5-1+1);
	Dessin = new Etoile*[NbSegments*2];
	for (int i=0;i<NbSegments*2;i++)
	{	strncpy(tps4,lesSegments+i*5,4);		// numero HR
		HR = atoi(tps4);
		//cout << HR << " ";
		Dessin[i]=VouteCeleste.Rechercher(HR);
	}
	//cout << endl;
	//liste.ignore(5,'\n');
#endif

#if defined( LINUX )
	liste.read(Nom, 21);
	Nom[21]='\0';
	//cout << Nom;
	liste.read(Abreviation, 3);
	Abreviation[3]='\0';
	//cout << Abreviation;
	liste.read(Inter, 19);
	Inter[19]='\0';
	//cout << Inter;
	liste.read(tps,2);
	NbSegments=atoi(tps);
	//cout << NbSegments << " : ";
   	liste.get();
	liste.read(lesSegments,NbSegments*2*5-1+2);
	Dessin = new Etoile*[NbSegments*2];
	for (int i=0;i<NbSegments*2;i++)
	{	strncpy(tps4,lesSegments+i*5,4);		// numero HR
		HR = atoi(tps4);
		//cout << HR << " ";
		Dessin[i]=VouteCeleste.Rechercher(HR);
	}
	//cout << endl;
	//liste.ignore(5,'\n');
#endif

		Xnom=0;
		Ynom=0;
		Znom=0;
	for(int ii=0;ii<NbSegments*2;ii++)
	{	Xnom+=(*Dessin[ii]).XYZ[0];
		Ynom+=(*Dessin[ii]).XYZ[1];
		Znom+=(*Dessin[ii]).XYZ[2];
	}
	Xnom/=NbSegments*2;
	Ynom/=NbSegments*2;
	Znom/=NbSegments*2;

	return 0;
}

// Draw the lines for the constellation using the coords of the stars (optimized for use with the class LesConstellations only)
void constellation::Afficher()
{	glPushMatrix();
	for(int i=0;i<NbSegments;i++)
	{	glBegin (GL_LINES);
				glVertex3f((*Dessin[2*i]).XYZ[0],(*Dessin[2*i]).XYZ[1],(*Dessin[2*i]).XYZ[2]);
				glVertex3f((*Dessin[2*i+1]).XYZ[0],(*Dessin[2*i+1]).XYZ[1],(*Dessin[2*i+1]).XYZ[2]);
		glEnd ();
	}
	glPopMatrix();
}

// Same thing but for only one separate constellation (can be used without the class LesConstellations )
void constellation::AfficherSeule()
{	glDisable(GL_TEXTURE_2D);
	glDisable(GL_BLEND);
	float coef;
	coef=rand();
	coef/=RAND_MAX;
	glColor3f(0.025*coef+0.1,0.025*coef+0.1,0.2*coef+0.1);
	glPushMatrix();
	for(int i=0;i<NbSegments;i++)
	{	glBegin (GL_LINES);
				glVertex3f((*Dessin[2*i]).XYZ[0],(*Dessin[2*i]).XYZ[1],(*Dessin[2*i]).XYZ[2]);
				glVertex3f((*Dessin[2*i+1]).XYZ[0],(*Dessin[2*i+1]).XYZ[1],(*Dessin[2*i+1]).XYZ[2]);
		glEnd ();
	}
	glPopMatrix();
}

// Chek if the constellation is in the field of view and calc the x,y position if true
void constellation::CalculeNom()
{	if (acos((XYZVision[0]*Xnom+XYZVision[1]*Ynom+XYZVision[2]*Znom)/RAYON)>((float)Ouv+4)*PI*1.333333/360)
	{	dansChamp=false;
		return;	// Si hors du champ
	}
	dansChamp=true;
	Projette(Xnom,Ynom,Znom,x_c ,y_c);
	return;
}

// Draw the name
void constellation::AfficherNom()
{	if (dansChamp)
	{	glPushMatrix();
		glLoadIdentity();
		renderBitmapString(x_c-40,winH-y_c,(void *)font,Inter);
		glPopMatrix();
	}
}
